Description

The attached patch fix-2fa-argument-error.patch fixes the error described below. The error occurs in development mode. No problem
in production mode.

Steps to reproduce:

. Run Redmine in development mode (bin/rails s)

. Login with any user

. Go to "My account" and click "Enable authenticator app"

. Setup up two-factor authentication for the account

. Update some source file of Redmine (e.g. run touch config/locales/en.yml)
. 2. Go to "My account" and click "Generate backup codes"

. You will see the following error entering your authentication code

NOoO Ok W=

ArgumentError in TwofaBackupCodesController#create
A copy of Redmine::Twofa::Base has been removed from the module tree but is still active!

ArgumentError in TwofaBackupCodesController#create

A copy of Redmine::Twofa::Base has been removed from the module tree but is still active!

Extracted source (around line #138):

tokens << token

end

Mailer.security notification(
@user,
User.current,

{

Rails.root: /Users/maeda/redmines/redmine-trunk

Application Trace | Framework Trace | Full Trace

lib/redmine/twofa/base.rb:138:in ~init_backup codes!'

app/controllers/twofa backup codes controller.rb:49:in “create'

lib/redmine/sudo_mode.rb:64:in “sudo mode'

Related issues:
Related to Redmine - Feature #1237: Add support for two-factor authentication Closed 2008-05-14

Associated revisions

Revision 19995 - 2020-08-31 10:29 - Go MAEDA

Fix that Redmine::Twofa::Base raises ArgumentError in development mode (#1237, #33925).

History

#1 - 2020-08-30 09:24 - Go MAEDA
https://www.redmine.org/attachments/25898

- Related to Feature #1237: Add support for two-factor authentication added

#2 - 2020-08-30 12:42 - Felix Schéfer
Thank you for catching this bug. The patch looks good to me.

#3 - 2020-08-31 10:30 - Go MAEDA
- Status changed from New to Closed
- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the fix as a part of #1237.

Thank you for checking the fix.
